#ifndef operation_h
#define operation_h

/*
 * $Id$
 *
 * NAME:
 *	operation.h -- Copyright (C) 1998 David Corcoran
 *                corcordt@cs.purdue.edu
 *
 * DESCRIPTION:
 *	The functions in this module create operation type commands from
 *	their arguments. The result is fit to be passed to the card reader.
 *
 * AUTHOR:   David Corcoran, 4/16/98
 *
 * LICENSE: See file LICENSE.
 *
 */

#include "defines.h"

bool
Operation_ManageChannel(
	BYTE status,
	BYTE identity,
	struct BinData *bindata
);

bool
Operation_GetResponse(
	BYTE size,
	struct BinData *bindata
);

bool
Operation_Envelope(
	BYTE size,
	BYTE *data,
	struct BinData *bindata
);

bool
Operation_JavaExeInitApp(
	BYTE *fileid,
	BYTE mode,
	struct BinData *bindata
);

#endif
