wm title . LinuxStat
wm iconname . LinuxStat
option add *highlightThickness 0 
if {$PowerUpdateTime} {
  canvas .c -height 26 -bd 2 -width 220 -relief raised -bg gray35
} else {
  canvas .c -height 21 -bd 2 -width 220 -relief raised -bg gray35
}
pack .c
set fg bisque
#set font -adobe-courier-medium-r-normal-*-8-80-75-75-m-50-iso8859-1
set font -adobe-helvetica-medium-r-normal-*-8-80-75-75-p-46-iso8859-1
set f2 -adobe-helvetica-bold-r-normal-*-12-120-75-75-p-70-iso8859-1
set f3 -adobe-helvetica-medium-r-normal-*-10-100-75-75-p-56-iso8859-1
.c create text 30 5 -text mem -anchor e -fill $fg -font $font
.c create text 30 11 -text swap -anchor e -fill $fg -font $font
.c create text 30 17 -text cpu -anchor e -fill $fg -font $font
if {$PowerUpdateTime} {
  .c create text 30 23 -text power -anchor e -fill $fg -font $font
}
.c create line 35 6 60 6 -width 4 -fill red -tags mU
.c create line 60 6 70 6 -width 4 -fill yellow -tags mB
.c create line 70 6 100 6 -width 4 -fill blue -tags mC
.c create line 100 6 135 6 -width 4 -fill green -tags mF
.c create line 35 12 70 12 -width 4 -fill red -tags sU
.c create line 70 12 135 12 -width 4 -fill green -tags sF
.c create line 35 18 55 18 -width 4 -fill red -tags cU
.c create line 55 18 70 18 -width 4 -fill yellow -tags cN
.c create line 70 18 100 18 -width 4 -fill blue -tags cS
.c create line 100 18 135 18 -width 4 -fill green -tags cI
if {$PowerUpdateTime} {
  .c create line 35 24 100 24 -width 4 -fill red -tags pU
  .c create line 100 24 135 24 -width 4 -fill green -tags pA
}
if {$PowerUpdateTime} {
  .c create text 180 16 -text 12:52am -fill $fg -font $f2 -anchor s -tags tT
  .c create text 180 15 -text {Wed Oct 16} -fill $fg -font $f3 -anchor n \
     -tags tD
} else {
  .c create text 180 15 -text 12:52am -fill $fg -font $f2 -anchor s -tags tT
  .c create text 180 12 -text {Wed Oct 16} -fill $fg -font $f3 -anchor n \
     -tags tD
}
bind .c <1> {
  if {[winfo exists .m]} {destroy .m}
  menu .m -tearoff 0

  FillToolsMenu .m
  tk_popup .m %X %Y
}
proc About {} {
  if {[winfo exists .a]} {destroy .a}
  toplevel .a
  wm title .a {About LinuxStat}
  wm iconname .a {About LinuxStat}
  button .a.b -text Dismiss -command {catch {destroy .a}}
  pack .a.b -side bottom -pady 5
  message .a.msg -width 10c -text "
By D. Richard Hipp
Hipp, Wyrick & Company, Inc.
6200 Maple Cove Lane
Charlotte, NC 28269
704-948-4565
drh@acm.org" \
    -font -adobe-times-medium-r-normal-*-12-120-75-75-p-64-iso8859-1
  pack .a.msg -side bottom -fill both -expand 1
  message .a.msg2 -width 10c -justify center \
    -font -adobe-times-bold-i-normal-*-14-140-75-75-p-77-iso8859-1 \
    -text "A Desktop System Status Monitor For Linux"
  pack .a.msg2 -side bottom -pady 10 -padx 15
  label .a.title -text LinuxStat \
    -font -adobe-times-bold-i-normal--24-240-75-75-p-128-iso8859-1
  pack .a.title -side bottom -pady 15
}
menu .m3 -tearoff 0
.m3 add command -label "Help" -command Key
.m3 add command -label "About This Program" -command About
.m3 add separator
.m3 add command -label "Exit" -command exit
bind .c <3> {
  tk_popup .m3 %X %Y
}
proc Key {} {
  if {[winfo exists .k]} {destroy .k}
  toplevel .k
  wm title .k {LinuxStat Key}
  wm iconname .k {LinuxStat Key}
  wm protocol .k WM_DELETE_WINDOW {catch {destroy .k}}
  if {[catch {label .k.l -image key}]==0} {
    pack .k.l
  } else {
    label .k.l -text "Not available..."
    pack .k.l -padx 30 -pady 30
  }
  bind .k.l <1> {catch {destroy .k}}
}
catch {image create photo key -data {
    R0lGODdhZwJbAfcAAAAAACgoKDjwMFBQ+GBgYIiIiKioqPAQQPjgwPj4APj48Ai/AFA1AU+y
    ABYBAAhAANxs0EdJRxYWFggICMhUgDL39gj//0C/vw4EYMAA9gEA/0AAv1DIbwEytQAIAQBA
    QFDw8EhAQFDwUE9AT4Bk1PhPR/8WFr8ICDEb/f1bRwIAFkAACE4EUEgATxYAFggACGgEnjkA
    vQ4AAQgAQMHwKHpAAAsWAEAIAIwEDUoAABIAAEAAAADwJQBAAAAWAAQIAFgQFHb4SBL/Fgy/
    CFg1vHay9hIB/whAv+gEbrkAjQ8AB2jwnkhAvRYWAQgIQFAEKEgAABYAAAgAAMjwDTJAAAgW
    AJwoJf//AL+/AJQ1HLWySAQBFkBACAPovABH9gAW/wAIvyCooEf3jRb/Bwi/CEwE8AIAQAAA
    FgAACMjIgzIyAEBABbjwUPhAT8TwKL9AAAQWAJhkEEZPABYWAAgIACAbJkdbAEwEEgIAAMjw
    ZgRYyPn49v///7+/v901TnSylQgBBwhACGwcGEdIcA4WFQDYAQD3AAD/AAC/AHgEW/kAx/8A
    Er8ACAjI2HAy9i4I/0BAv8jwNTJAiAgWB0AICHTw1PlAbf8WFXhkJPlP/P8W/78IvwgA2HAA
    +S4A/zQf3/kAfP9ABb8FCMAAZqcAAAcAAAD8AAEEJAAA/AAA/wAAv2cEJAIA/FvwSAFA+QAE
    AADwAAFAAAAIAHygAPn4AHg1APmyAP8BADS4JPlH/PwoUKf4Twf/Fghv4HC1Ry4BFmcwyAL4
    MgD/CAC/QFtvDgG1wAABAQBIUgBJASRQZPxPSABABAD4AABv8AC1QAABFgBACAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
    AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAZwJbAQAI/gAVCBxIsKDBgwgTKlzIsKHD
    hxAjSpxIsaLFixgzatzIsaPHjyBDihxJsqTJkyhTqlzJsqXLlzBjypxJs6bNmzhz6tzJs6fP
    n0CDCh1KtKjRo0iTKl3KtKnTp1CjSp1KtarVq1izat3KtavXr2DDih1LtqzZs2jTql3Ltq3b
    t3Djyp1Lt67du3jz6t3Lt6/fv4ADCx5MuLDhw4gTK17MuLHjx5AjS55MubLly5gza97MubPn
    z6BDix5NurTp06hTq17NurXr17Bjy55Nu7bt27hz697Nu7fv38CDCx9OvLjx48iTK1/OvLnz
    59CjS59Ovbr169iza9/Ovbv37+DD/qMEoIA8gPPoFZIXuF59efHw9ZpnP/A8wvbt3eePz1/u
    /Pf13RcgQ//1Z2Bd+JmnYHn2pcfeegsetKB99UHI4IUV0ocehPsd6KFQG+JHH4AkWoihgACa
    qOKIKq74oW3/pRdhRRQWqFR+Lor4YI0L5ehgjiwGSOGLtM2X4IgWWdjhUTgGWeKAUKLo4oBA
    Prkkka8ZSZCJSWrY1JEpIgmmjRI6yWOVXJ6I5W1D7rilkhy+eeV7DeIIp5pn/jjnRSHaSWeU
    MrZZUKAYBjphnAzquGZuDobpKI+PuhfppD46udaei8oGaYJcbmhpmY/+aKalM6aFKWCCPphV
    qrE1SamY/oMiCeqUo07656Wnorofq1TlqlqNaIqppKwGVXprsBlmmpCgvI5nkqJFJuomsIly
    muGVhAKr4KGqSkussrGKOOaFbeZJrYZ+VjtonA1Ke26EnsLrq7LzEllgjLUam+arJFJpJqLI
    2gqupAPPGuqm+Qq5a8KxbklqhQg/SWe9azY78LCO+svvrQ5vHKWt0ILsZcEkT6QowPymmWrA
    Gk85rsvJlixzQ6J6ayi5AA/ZIaF47upnvDrXKW/NM/9EMXZHw5R00S1Z3N3SLkHN9EpOb1d1
    TVdPLVPWWnftFddehw22UWOH3XXZRKENm9NSP6S22WpK9XaWW8NN0dxA4d1a/tsb8e213jw1
    Gpzg1JbqqapBg+mm3Sb7vRPgrCFbZcsMO6415DphfneJ7RKIKZmmsljz5P/KSSvjEGl+k+oS
    xYgogT32q9bpPu4sK6Qaox4R61hbvrnKDn0ue+gpYtypwaGO7PvUvM/U/Ob3petttwLW+Sa6
    PaN7bt7lCs2z4IhPP33nuru9fO80YVv5p8Wun/LpTZcUcvknPa/0+V1Gv2+LFtcuOaz2Mx/+
    GjY8+slvgDEJYOs6Rjv2SYl9/xvZS8AXEgoa8IBQsWDUUJaybs1JXx3slwI9h8ALpq+ETUPh
    3Qjnumlx6IPW05a75LW4AqZEgyb8kgqptkOu9HBZ/iPM4f2eEkSt/BCIQqwKDotSRKw0UUJH
    TOIGdbi2KEoxhVR0zROviEWmbPEjVszcF7nIQy+G0SNjtMkSyWjGpayxJ29UYhrZeMMzgtGO
    HJmj8/RIx/HgMY9/zAgfEzjIPj4rkBopZJIQOUFFGpIkjlwkkxi5QUo+EpKWpFEmG/eVOF7S
    jZtsXShTN8r6RfKTIzmlKCf5NVWisoKlNB/ZYolJWgpHRkQcoCuDt0sStvJsMfsSSHrpuVn+
    Epgfc+MwbakeZuqvK8QsTve4VSgLGkp62bte4oLpSVE6E4pM/CYaxXlLnblvYSEkXTod2Ddy
    Xm8o3dShO8sZvm1mjHoZ/iPajtD5OnXdsyPRjF44fRhQ4rjqTzqCX6EYlsxP4Y6diZxn3Iwm
    UYzEE1zbI5/H1pk8EebLeCIp6LrSVtFFlrRHfVoh6FRqw0uJb39GWpk9w9ezncXUTkdCoEjf
    GZSdtvOksGtoUCdqsmAaxldAbSaIfIpPq1wUnhbtGJ+kehikTsWnTCXqVbO6QC9tb6LTxJkH
    KThNbHbPP1V7Kvd6Ok+uajKpNDtcxPY1vnMWy5wchetisOpOt7LUqbmTqwYLd6LRCTSfD/Xn
    dPjKVr3G1bFDhRI6CWglidHKVSxraV/8ilKKLtWJnD1s+wiYJ2FRT6Oke9c56cqXw2URjuRU
    /utA5SnTmTaKcC8lVrvAty2IaROfso1LcHMiUsZeJbR33eW8IOsU197ImTsdLltp+zi3dca5
    rAxcdJmLRFBGM47SPWp4t8bM7R4XuYrFEnbh+V1xoteXSFmvesfbSO16Vo5AlW+m9OuT9t53
    qyflL0bdSszicje5s3zvbAQsxgb398ByCid9DTRhPzrYvgAmaYUPxGA1xjKgG/ZwWzt8OeOK
    GLYZXqqCf0Ni8uIExCteV19DTC8aj/PF5YWw+GAbY4PaGJA41q6Ot9vj47S4i+h73JC/eWQT
    NlklgwwahjMI3R+X2JV45WGIVsfT5ua4yNGxsknF3Mw+URJoUSEz/p/ULDY2k9DMKTQzI+Gc
    yw8/+ZFuBqKc7bjnPW45KTgl7p0/OWhAyjnOKSUvnSVcw97luXyPTm6itfxnQvZZwoWupY6/
    k2mLHpoln7b0otlb6ROCOT6dHnOqVe3IS2N61YbeNH9g3bhS19HWjZy0hkeN6FeGNNK89iOt
    I6prUrua0r7WNJRxbcphC7LYxg52s2V9HANY+9rYzra2t81tbG+o2+AON7j7JO5ym1vbITq3
    utedbXKz+93wNveeARDvelv72/bOt773zW94ByAAiem3vM8j8HCnu+ADRw/C633whTsc3XJ+
    +LgVLvGKW/ziBvh3wDF+bXxb3OMcvzfF/kM+cZCTfN8RP3nDT87ylptb44hp+cglbnKO19zl
    Blg5zhnu7pDrfOdAxzkBCADzw7j85gWfuc+VvnOkB/3cPbe5059OdYwPveiGyXYBts71rnv9
    62APO9jRI/aym33sADi72tf+dbKz/e1w97rb4073uq89RHbPewE2pPe++/3vgP/70K8O8Jhj
    O/Bv5zvi5X6exd+98Y63+9wjT/m2T77yjIc85jfP+c57ffBEL7zRD/93BJj+9Kf/uum3viHU
    p/7vmvc819Mue7XHvvaIv3znFY/73vu+76DHemG0XnrXv77rq2c9eowfeNr33vm/b3v0cw/9
    3et++tjPPtiD/i/6rJPe78kvQPLHj4Cth7/15Rd/+sV+gPa7//3wBwD850//+sM/AfjPv/73
    z3/+D+D/ABiAAjiABFiABniACJiAAigADNiADviAEBiBEAgAEliBDZh3vNd3xud6areB64d8
    G6h9mMd9G3dtgBd+5Gd+6YeCraeCe8d+9heDMjiD79d/NniD+aeAOriDPNiDBWiBQBiEQliB
    dZeB4OeB4Vd2Hgh2SyiClEeChmeCxcd1Kah+qEeF5cd3pnd9BUCDXviF94eDYrh/PliGZniG
    CziEariGRBh21Td7XKh3HPh2V4iFKHh8VviBTgh4UDh6UniEWOiCeXiH5rd8CGCE/lsHhoro
    hWPYiPiHhpAYiTrIhpRYiQLghreHiCdYh2zHiXlohx/oiXsoeIMnfIRBfIAoiFXodeS3Z1+3
    iLAYg47YiJJYi7aYhpaYi0GIdpqHd443h0ooiqyIh0z4enPoiXdYh8wXfX3ofX+ogetXhUkY
    iOqnfH3idbGYjfM3i2N4i95Yi7oYjhZoea5IecAodueoesSojuRnjHiYjO4ojLXXjMP3fdBI
    jUnIiVVYjomojf54ANwoht84kGgojgYJgZlnZpuHhNM4iGEnjyCYj8uojMj4jhC5efR4ivYo
    h9G4gqF4fCk4b873j/4YkDhIkCjpgwe5kgzYdfyIeQyp/ocOWYwNOYwSeYzxeJMfuY6dl5GD
    gYpOKJK3N4pEWZTTN2/Td5HsKJM2KZPnSJEWqZNMyXk+KRhAGZRCaZRauZWyJ5RvKHtK2ZRm
    J4xPmZM7eZZTiZGl2H31+Ix0B5Wq6JHTuIwiyZV2eZfU55W/F5YqWJMROZVl2Y46+ZdpOYJr
    WYLWxpHtGJd9qYfLCIcKiZeSOZlw55VDCZY8uZRjmZmBKZeDCYqFWXlVGRhXSYdOKY2n6ZEg
    mJAbQpKu+Zo0yJKyOZuzmZWYGZWhGZZK2ZmNeZaE6XujCRil2YmpyZg2KYjIyZryB5vM2Zzt
    R5vQGZ2W+JK1x5vB6JegeJ2f/mmdvQmchxmFiZl3cFmN5BmC5JmcvLiczrme/yid7vmeFniN
    2MedM6mbmdmbgtmd2Qma3kl4iGkAiimXxmmeEml27Yce7Jmg2QifDNqg6NGS2kefOImdjamd
    OamfFcqfvRecfzGccTeXqomPq3ieYRd/CnqiYNigKqqie4iES+mZTTiIBAqVaPmXv7mh3+mH
    4cmRw5ici0miFNqFKDqkiriiRvqeLRqjGhqTHcmQ+lmRuHmjuMehfuGhHciTI6qP5mmgRNql
    sXmkYEqblNl56TimXUelfWGlZyePWQqSW1p2XhqnMRimdMqSZrqQfCmZaMoXalqdoXmngBqo
    gnqb/kE6mXu6F32KmYO6qIzaqDCZp3h5qHqRqNAomBaJno6aqZq6qQ8JqXcpqXlBqQGKnx+J
    qZx6qqjKqGUKqKCKF6Jadw0JosYJg+tpkvqXkgdYp7rKhqnaq2/Xqnfxqm95mj1anqGZoLaa
    g7j6g7varLvoq9BqdsBqF8L6ocS6msbKpbWarAmwrMzqrOAagb33mOaYm38qnmlJros3rXVR
    rXAXq44ZokGKrNzqrQQYrvj6gOO6qogXpIWKrujIr6Ton+AJoOWqjsU6omBHr8lqrwOYrxB7
    iYparJFXpp76rlh6reuao864o7+osQN6rOzpiADQfw6LixELnw8KhH6K/rDluo4Xa5o1Ca+R
    x6504a7WaqnwOq8j24gl638nC4Apq6JmJq4T26mlaqz3qaE2KqNJa6ouS7HUuLEEq6MGW3k0
    CrNLK6T0h6DZSLImG7T/N7REO28Q6nkUeqlKW6gWa5YFOrXBWIxRi3g2Oxc4y6ORp4l56Xhf
    Ga16Z5mXWbGBia2imLYdOasu+7abKbdSG3h1Kxd3C7B5GYfNF7h9Z7l+W4SWSaaDK6KyGrAi
    CrXZCregO7eiq3ePGxeJ+qYZGrokCqQhKnaRuXmUi4GYm7lxp5e+96OIS7oUi5qECbxrN7Mg
    67gc25Yei7RkSYzCC7cKC5nyyXm1a7u3i7ts/meb+9qXhMuUhuu6Utm8a8q9xcuHx6uRbkmT
    2xuRIau9a4uJe1akubgh0BkiZBuxSMl5NGuF6Wu6jfu2n/u8pdu4r0u+VduxVxuwSXuT66u/
    7euSQrmIuii/80u/9Yuv9/uoieu/4hu32Nq74Lu4/PuvdJe6cLG6Gqy+o6uzsQu97wvB8buy
    E0zBFQyudXmwCXvC/NvBPrrCsCvCAzzAPgx3JPwWJpzAO7nAM5qeZhaLESzBtClnMxyuvOeL
    i5e/aku8HOy8PPyZV8q4Omy8BYy8B4y0+8u+iKu1StwnTDydMvzEUBzFzXp5VNyvqzqRGxzA
    O3yjAJzFL3qudjfE/m5RxGXMwGecv+SoxmtciX0inWYbxRSoq307x8XHpjjpxZYMu3rMw+GL
    wFuLuuX7kxtJk8uLxT9Mke4bIjKonvT3wm1cm41cv+exq2Unydbru5/6yVYZyn2cmndMvM/b
    wjGoyvPHyk7sxq88tDAcpmdHy9YbxE4IyG0hyNHndszswHwbvXlLnVs5vdlXzb7qzHsIzWwh
    zb43ebXLzbk7u9mMzXapt6PozagKzs+My6Spy1g5lH1rzdfMzounzncJz++MzrVMlOK8FpEr
    vdXrvusM0H7nz1zJz9ss0AMtggWtFtkGehid0Rq90Rzd0RuNHh7N0RsS0iSd0fNW0iht/tLn
    MXQgndIu/dIkHSIwPdM0rdEjXdM4ndM6vdM8XdKmCMrX1tM93dIwfdNCDXorfdQijdRJrdRK
    3SdOHdWDZ9RSXdVWfdUo/dO5bABY/dJU7dIyLdVN3dVMDQBkjdNmdtZDTdRq3dZuvdNaXc9c
    /dYiPdZeHdZRbddqzdZ0HdJy1tdo/dWAPdiETc+A8W+IndiKvdiM3diO/diIjR6QDdlmNtmW
    /djncdmavdmRndmc/dmgzdhyFtqkXdqNHSKmndqqvdqs3dpxfdiuvdqSXdqVHduJ7dm2vdmz
    ndusvWe8/duKjdrAPdzEXdyLzWLSJW0ANWftFWoJdmqME17O/g1LiqZkx/bc1HY2gDPdy+Rn
    1g1tkxRpyaZnz6bcy21qYsRszyXe4w0xfjNvGITeOKbe3gXdJFNh193djjbfTZVm7I1KNGbe
    QOZhxOVbTvXfhmRjAt5OQTZlB27fH+JsI/Ut+r06toTgoIbhQmRlX9RL/rUVEu5rYtbhtFRg
    EK4/J+4dI07i1q1knRTibKRmY9Tc6Q0W9N3eCBbfy8ZjF/biGs40bDZHMGZnY3Hj4+1mQl5l
    pZTivPTjA3ZEemRgS57dpOTkFfNEUe5eWEbluwPjf4PlWd5YDY4WXl40Zd5dUyTmBI4rTO4b
    7M1HWWXlXWYqcs5pM45IXFXnWnUW/md+5XyG5xWl522+ZoOuKf/9435V54VO6IseOWFOSOGd
    ZMLV5+Kh4YUUWnKu5w+m6cth6WeWVJnO5ePE6cZB6XG1R88l3wjyObv1Z3piLdeyXG5+6ZmE
    Xq0m6ju+UB5EVcPDWqWuSJH0XsDe6PLDQMb+MbajWcpeG1au6I417IGhPruO7BHGOTKGS9Zj
    VKdh6rIk6aluaaiC4tAyWZmVUAy17aeU7pDl5MQeUihCWeT+L8xCOcXT7uu95t5+7/eD689y
    7PBOWrUyWiGUGpquSj2G6Pwe34k1VgDfUQeFJr5+XQVv8Afm6QmvbDu2TzIW6zJ07WjW8aNB
    6lvu34Fk/u8GROp7Xl8kP0Q4nmA9nu9e9kcmH90fbuG98ugtzz0XTuQ3j0cz32Y55uI9n+Y5
    /908/vIrn+FF3+IP5uApVkZLb+Fa7vRPX0dRf2L/hfRVb2FXL2rTRfVDn+tdX0kqhmJGxOJj
    n+Ej1vQgHkYoT2h5XmXQ5PZ7At5O9O7Uwe03xvYEtWx1r+1pX+XGxPd9b/XLwuuSFfiixV5r
    9eI3FDun9UKuDicZxUIuVE3Yk/mldVbkgvmG8/Ytvi2v3mj5w0uUBfjWBfmpNPU+bmp4dTyl
    808RZCzJMvt29U+TPu26TuH9TjPxZWJzf2ZSRTSccjzzTikxpfG97t4Bb1gc/kUXmOXvy15B
    wdP7d/RZNn7pxw77siMuowUz93L6EkPvtl/vdiHtu+9RH79QhFVW1Z44vYXi2vMy1/RVmoT9
    2Y/ntf8wu45NDIVaAAFAgQKBAgceNEjQYMGBCxs+JAjRYUSKFQ9exJhR40aOHT1+BBkyZEKM
    AEyaRHiRpEKJLSlOhAkx5UuXEzXCjPkyJ02RHFH2BBpU5E+hRY0eHUoUqdGTJ1UyZBnVqVOZ
    T0kqtdkQJVWtCaduLbgwbNOxZKUqXZpW7VqPK2eWVAm35lyeO+nmFEt1J96ZXqMiRctWcEm3
    gw0fVlgY8eKMhRUzRuwX8mTKcl1atliRb92agfES/s0q1+ZmnhEf9+RaOW1g1a1HsnYtWPHp
    2IDf1sa9WmxVhLvj3gWu+eblq7x/j6Zb+u9R2LlfO4d+s3n0oKxTU2c+Hfv2xnqtX+cKVvz4
    pmevku+aeLnV9N7b/4SvVjv3p/SjX7efX/9+/tslt72tI9qEGhCk+fQ7sD/D8FOwQQcfhLCo
    /wQM0CfZ5CswvwQj1C1DDj8EMUTuGNyIxO48/GhDAVGkT0URCXTxRRlnpLFG3GL0j0UbDcRx
    Rx9/BDLItnqkjkgh2TsySSWXVNLI+5jMTkcop6SySuictJJDE7PksksvGcPySwfDFLNMM80k
    88z90lSzzdbKM803rerr/s0r0M6T0sct3XyRTT7/XAyn4DYj1Lgq/QQ0x0QXtW+vy7qSczk4
    EQ2R0qkS8y4v+VDLc6QUa6OUUVEJJO7RzObszdBQIbTUNzur6nSpWCtddVRbPy2NUId0fSi0
    Q2ct8ThhK6wM2E3frPVWZU9MD1Vn1YM2Wmj3bNLYxoJFtbiUyttKqrPitEpb81j6Lj44veXW
    rPUGo3ZZd217V7cFSzxX3GwHxXdY0q7V6S5HT10w2XhttdbddqvDFrOVJCuUM+Uc7ha+SUt1
    ONd1Dzt4YI1XLFjZVbV17Le3GtbVLUehwha5ipHrOEWBN4Y5ZjoDvre7Z4WDODiA90I5ZZlI
    /svqZSRlJrrotZKdtNyF78QU07LSbbZZrAxF8itXxasZ2ZaN5npgoVskljl2Qe26bLN53LrB
    CVe78Gy3374v7TH9zNhluO/GG9m89+a779y+9jtwwfEGfHDDDy+6cMSBupQsTaUVG7Xn7JZ3
    caIVt5zHrOMLe0RPj81847pDnwzkYal+EnXM4CXda7kJMzdSrPCsM9XaDU6Yc1ibjnjX3cIK
    N1Xgg0/Ns599H97Z11uHUmhBc4ae5Hdnq1fkmqWHvi/eGDYV5ecbZt7g5UX7uXv3bIf0Zo8T
    tn5h7aPXObnydUJrdt1x0j18j8fX9333bbadY/h3JNPxa3v+y9fj/vonMrvEZW3cy8wA9fej
    0UVOZZ/plb8yCLBRSUxVkcIZ9lRGvgj6L2gS2ZUJNzhBgklQakxD37TuRDvILStpAqwf09Jl
    NbNIDE9fgR1YoobC94xlXBVkYZcA58Ikgo6JTXxb4Z4IxchxkIpXXCLmrlgdLW4xcVP0YhjF
    +KAujtGMZ8QOEtG4RjZ+qIxthGMcIwNGOdbRjhi6Yx71qKA37tGPfyQMIAU5SC6ei5CHRCRb
    XpVIRjZSQtZjoCMlKclFmkddsfNg+gIoxEwmb5KfzJu6VqbCh4mwM6BEZSgZeL86sex/GBze
    xFI5yygu8D//Mw2/ToazztHSlzBb5L/QvzUzBGqmZ+b6ZTK/aMhufUs94ZHOeU5XRGVWk3kh
    s2Y24zgbbXZzjeXyZjjFOU5yltOc50RnOtUJQFKt0521bOc75Vm2PNFxnvckY/LCQ8Oh5TCY
    F8NnQJuUwANWbH4gFGhCk/Q8TYZmaiW8nT0VOlHXBM2hH+xeMSm6USDxKpcQbSAEJcpRkgaK
    IcXT4dDWJU1DltSlL4VpTGU6U5rW1KY3xWlOdbpTnvbUpz8FalCFOlSiFtWoR0VqUpVqo4AA
    ADv/
}}

UpdateTime
UpdateMem
UpdateCPU
UpdatePower
